#Demonstrate various random distributions.

import mathkit

#set seed for random number generator
mathkit.randseed()

#poisson distribution
print("Generating 100 random numbers of poisson distribution (lambda = 2)...")
poisdata = mathkit.rpois(2, 100)
print("The sample mean is", round(mathkit.mean(poisdata), 4))
print("The sample variance is", round(mathkit.var(poisdata), 4))
print("The probability of X = 4 is", round(mathkit.pois(2, 4), 4))
print("The probability of X <= 4 is", round(mathkit.pois(2, 4, True), 4))
print()

#binomial distribution
print("Generating 100 random numbers of binomial distribution (n = 100, p = 0.5)...")
bindata = mathkit.rbinom(100, 0.5, 100)
print("The sample mean is", round(mathkit.mean(bindata), 4))
print("The sample variance is", round(mathkit.var(bindata), 4))
print("The probability of X = 45 is", round(mathkit.binom(100, 0.5, 45), 4))
print("The probability of X <= 45 is", round(mathkit.binom(100, 0.5, 45, True), 4))
print()

#exponential distribution
print("Generating 100 random numbers of exponential distribution (theta = 2)...")
expdata = mathkit.rexp(2, 100)
print("The sample mean is", round(mathkit.mean(expdata), 4))
print("The sample variance is", round(mathkit.var(expdata), 4))
print("The probability of X <= 1.5 is", round(mathkit.expo(2, 1.5), 4))
print()

#normal distribution
print("Generating 100 random numbers of standard normal distribution...")
normdata = mathkit.rnorm(100)
print("The sample mean is", round(mathkit.mean(normdata), 4))
print("The sample variance is", round(mathkit.var(normdata), 4))
print("The sample skewness is", round(mathkit.skew(normdata), 4))
print("The sample kurtosis is", round(mathkit.kurt(normdata), 4))
print("The probability of X <= 0.8 is", round(mathkit.pnorm(0.8), 4))
print()

#t distribution
print("Cumulative probability and quantile of t distribution with 3 degrees of freedom.")
print("The probability of X <= 0.8 is", round(mathkit.pt(0.8, 3), 4))
print("Quantile of p = 0.6 is x =", round(mathkit.qt(0.6, 3), 4))
print()
