#Demonstrate the main functions for matrix and linear algebra.

import mathkit

A = mathkit.v2mat([2, 1, 0, 1, 2, 1, 0, 1, 2], 3, 3)
print("A =", A)
print("number of rows:", A.nrow())
print("number of columns:", A.ncol())
if A.square():
    print("A is a square matrix.")
    print("The trace of A is", mathkit.trace(A))
print("A transpose is", mathkit.t(A))
if A.symmetric():
    print("A is symmetric. So A transpose equals A.")
    if mathkit.positive(A): print("A is positive definite.")
print("A(0, 1) =", A(0, 1))
print("Set A(0, 1) to 8...")
A.set(0, 1, 8)
print("Now A =", A)
print()

#determinant
print("The determinant of A is", mathkit.det(A))
print()

#lu decomposition
lup = mathkit.lu(A)
if lup == (): print("Singular matrix!")
else:
    L, U, P = lup
    print("L =", round(L))
    print("U =", round(U))
    print("P =", P)
print()

#qr decomposition
qrmat = mathkit.qr(A)
if qrmat == (): print("A has dependent columns.")
else:
    Q, R = qrmat
    print("Q =", round(Q))
    print("R =", round(R))
print()

#identity matrix
I = mathkit.eye(3)
print("I =", I)
#multiplication and equality
if A * I == A: print("AI == A")
print()

#inverse matrix
print("inv(A) =", round(mathkit.inv(A)))
print()

#ones and zeros matrix
ones = mathkit.matrix(3, 3, 1)
zeros = mathkit.matrix(3, 3)
print("ones =", ones)
print("zeros =", zeros)
print()

#diagonal elements and matrix
d = mathkit.diag(A)
print("diag(A) =", d)
print("diagonal matrix:", mathkit.diag(d))
print()

#rank
B = mathkit.v2mat([1, 1, 1, 1, 2, 3, 2, 3, 4], 3, 3)
print("Singular matrix B =", B)
print("Rank of B is", B.rank())
print()

#solve linear system Cx = b
C = mathkit.v2mat([1, 3, 2, 4], 2, 2)
b = [5, 6]
print("C =", C)
print("b =", b)
print("solution of Cx = b is", mathkit.linsolve(C, b))
