#Calculate the yield to maturity of a bond with coupon rate 8%, face value 1000
#and 5 years to maturity. Given the current market price of this bond is 1105.

import mathkit

def equation(rate):
    return mathkit.apv(80, rate, 5) + mathkit.pv(1000, rate, 5) - 1105

guess = [0, 0.2]
if mathkit.probe(equation, guess):
    ytm = mathkit.solve(equation, guess)
    print("The yield to maturity is {}%".format(round(ytm * 100, 2)))
else:
    print("Probe for maturity yield failed.")
