/*
Calculate the net present value (NPV) of a project.
The net cash flow of each year is 1200, 6000 and 6000.
The discount rate is 10% and the investment of this project is 9000.
*/

#include <iostream>
#include "mathkit.hpp"

using namespace std;
using mathkit::Vector;

int main(void) {
	//The components must be double type, so the important trailing "." couldn't be omitted.
	Vector vec = mathkit::make_vec(3, 1200., 6000., 6000.);
	double npv = mathkit::spv(vec, 0.1) - 9000;
	cout << "The net present value (NPV) is " << npv << endl;
	return 0;
}
