/*
Covariance, correlation cofficient and linear regression.
*/

#include <iostream>
#include "mathkit.hpp"

using namespace std;
using mathkit::Vector;
using mathkit::LineParam;

int main(void) {
	double xdata[] = {1.5, 1, 0, -2, 4, 3};
	double ydata[] = {1.8, -0.5, 2, -2, 5, 5};
	
	Vector xvec = mathkit::a2vec(xdata, 6);
	Vector yvec = mathkit::a2vec(ydata, 6);
	
	double covar = mathkit::cov(xvec, yvec);
	double correl = mathkit::cor(xvec, yvec);
	LineParam line = mathkit::linregress(xvec, yvec);
	
	cout.precision(4);
	cout << "The covariance is " << covar << endl;
	cout << "The correlation coefficient is " << correl << endl;
	cout << "The equation of regression line: y = " << line.intercept << " + "
	     << line.slope << "x" << endl;
	return 0;
}
