#Save the input and output values of an arbitrary function to file.
#Then the saved data file could be used to plot a graph of that function.
#Many plotting softwares could do this job well like gnuplot etc.
#And you could also load the data from file later.

import mathkit

def equation(i):
    return mathkit.apv(80, i, 5) + mathkit.pv(1000, i, 5) - 1105

x = mathkit.linspace(0, 0.1)
y = list(map(equation, x))

ofile = open("savedata.txt", "w")
mathkit.save_table(ofile, [x, y])
ofile.close()
print("Data saved to file savedata.txt.")

ifile = open("savedata.txt", "r")
z = mathkit.load_table(ifile, 100, 2)
ifile.close()
print("Data loaded from file savedata.txt.")
print("number of rows:", len(z[0]))
print("number of columns:", len(z))
