/*
Demonstrate some basic statistical functions.
*/

#include <algorithm>
#include "mathkit.hpp"

using namespace std;
using mathkit::Vector;

int main(void) {
	Vector data = mathkit::linspace(1, 10, 20);
	random_shuffle(data.begin(), data.end());
	cout.precision(3);
	cout << "length: " << data.size() << endl;
	cout << "maximum: " << mathkit::max(data) << endl;
	cout << "minimum: " << mathkit::min(data) << endl;
	cout << "mean: " << mathkit::mean(data) << endl;
	cout << "median: " << mathkit::median(data) << endl;
	cout << "variance: " << mathkit::var(data) << endl;
	cout << "standard deviation: " << mathkit::sd(data) << endl;
	return 0;
}
