/*
Demonstrate some vector arithmatics.
*/

#include <fstream>
#include "mathkit.hpp"

using namespace std;
using namespace mathkit;

int main(void) {
	ifstream ifs("vecarith.txt");
	Vector a = load(ifs);
	Vector b = load(ifs);
	Vector c = load(ifs);
	ifs.close();
	
	cout.precision(3);
	
	cout << "a = " << to_str(a) << endl;
	cout << "b = " << to_str(b) << endl;
	cout << "c = " << to_str(c) << endl;
	
	cout << "The norm (length) of a is " << norm(a) << endl;
	cout << "The norm (length) of b is " << norm(b) << endl;
	cout << "The norm (length) of c is " << norm(c) << endl;
	
	cout << "The dot product of a and b is " << dot_prod(a, b) << endl;
	
	Vector cp = cross_prod(a, b);
	cout << "The cross product of a and b is " << to_str(cp) << endl;
	
	Vector lc = a + 4 * b - 2 * c;
	cout << "The linear combination of a + 4b - 2c is " << to_str(lc) << endl;
	
	return 0;
}
